// Simple OOP example "Spot"
 
Spot[] sp = new Spot[15]; // Declare the object
 
void setup() {
  size(400,400);
  for ( int i = 0; i < 16; ++i ) {
  	sp[i] = new Spot(random(50,width-50),random(50,height-50),random(10,50),random(-5,5),random(-5,5));
  }
}
 
void draw() {
  fill(0,0,90,20);
  rect(0,0,width,height);
  for ( int i = 0; i < 16; ++i ) {
  	sp[i].display();
  	sp[i].move();
  }
}
 
class Spot { // Define the class
  float x,y,d,dx,dy; // x position, y position, diameter
 
  Spot(float xpos, float ypos, float diameter, float xdir, float ydir) { // Constructor for the object
    x = xpos;
    y = ypos;
    d = diameter;
    dx = xdir;
    dy = ydir;
  }
  void move() { 	
  	x += dx; // sober
  	y += dy; // sober
  	//x += dx * random(1); // drunk
  	//y += dy * random(1); // drunk
  	if ( x > width-(d/2) || x < (d/2) ) {
  		dx = -dx;
  	}
  	if ( y > height-(d/2) || y < (d/2) ) {
  		dy = -dy;
  	}
  }
  void display() { // Method (function) to display the object
    fill(255,100);
    //noStroke();
    ellipse(x,y,d,d);
  }
}